#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Fri Apr 24 18:32:21 2020

@author: ee18d001
"""
#!/usr/bin/python

from __future__ import absolute_import
from __future__ import division
from __future__ import print_function
from __future__ import unicode_literals

#import __init_paths

import cv2
import sys
import vot1
import numpy as np

class GOATracker(object):
    def __init__(self,image,bbox):
#        sys.path.append('/media/hd2/mohana/Operation_RedGiant/ALTO/draft/TransT')
        from bbox import get_axis_aligned_bbox
        from trackers.tracker import Tracker
        from trackers.net_wrappers import NetWithBackbone

        # create model
        net_path = '/media/hd2/mohana/Transt_jan2022/checkpoints/transt_occl.pth.tar' #Absolute path of the model
        
        # create model
        net = NetWithBackbone(net_path=net_path, use_gpu=True)
        self.tracker = Tracker(name='transt_occl', net=net, window_penalty=0.49, exemplar_size=128, instance_size=256) ###
        #initialise
        init_info = {'init_bbox':bbox}
        self.tracker.initialize(image, init_info)

    def track(self,image):
        outputs = self.tracker.track(image)
        return outputs
        

handle = vot1.VOT("rectangle")
selection = handle.region()

imagefile = handle.frame()
if not imagefile:
    sys.exit(0)
image = cv2.imread(imagefile)
image = cv2.cvtColor(image, cv2.COLOR_BGR2RGB)
trkr = GOATracker(image, selection)
while True:
    imagefile = handle.frame()
    if not imagefile:
        break
    image = cv2.imread(imagefile)
    image = cv2.cvtColor(image, cv2.COLOR_BGR2RGB)
    output = trkr.track(image)
    bb=output['target_bbox']
    region=vot1.Rectangle(bb[0],bb[1],bb[2],bb[3])
    confidence=output['best_score']
    handle.report(region, confidence)


