#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Fri Apr 24 18:32:21 2020

@author: ee18d001
"""
#!/usr/bin/python

from __future__ import absolute_import
from __future__ import division
from __future__ import print_function
from __future__ import unicode_literals

#import __init_paths

import argparse
import cv2
import torch
import sys
import vot

class OCCLTracker(object):
    def __init__(self,imagefile,image,bbox):
        sys.path.append('/media/hd2/mohana/Operation_RedGiant/ALTO/draft/PYSOT')
        from pysot.core.config import cfg
        from pysot.models.model_2021 import Model2021
        from pysot.tracker.tracker_builder_2021 import build_tracker
        from pysot.utils.model_load import load_pretrain
        
        parser = argparse.ArgumentParser(description='siamrpn tracking')
        parser.add_argument('--dataset', default='VOT2018', type=str,
                help='datasets')
        parser.add_argument('--config', default='/media/hd2/mohana/Operation_RedGiant/ALTO/draft/PYSOT/experiments/siamrpn_r50_l234_dwxcorr_16gpu/config.yaml', type=str,
                help='config file')
        parser.add_argument('--snapshot', default='/media/hd2/mohana/Operation_RedGiant/ALTO/draft/PYSOT/snapshot/three_ds_both/checkpoint_e17.pth', type=str,
                help='snapshot of models to eval')
        parser.add_argument('--video', default='', type=str,
                help='eval one special video')
        parser.add_argument('--vis',action='store_true',
                help='whether visualzie result')
        args = parser.parse_args()

        torch.set_num_threads(1)
        
        cfg.merge_from_file(args.config)
        
        
        # create model
        model = Model2021()
        
        # load model
        model = load_pretrain(model, args.snapshot).cuda().eval()
        
        # build tracker
        self.tracker = build_tracker(model)

        #initialise
        self.tracker.init(image, bbox)

    def track(self,image):

        output=self.tracker.track(image)

        return output
        
handle = vot.VOT("rectangle")
selection = handle.region()

imagefile = handle.frame()
if not imagefile:
    sys.exit(0)
image = cv2.imread(imagefile)

trkr = OCCLTracker(imagefile,image, selection)
while True:
    imagefile = handle.frame()
    if not imagefile:
        break
    image = cv2.imread(imagefile)
    output = trkr.track(image)
    bb=output['bbox']
    region=vot.Rectangle(bb[0],bb[1],bb[2],bb[3])
    confidence=output['best_score']
    
    handle.report(region, confidence)

